import * as Handlebars from 'handlebars';
export { safe } from './helpers';
export interface Template {
    (context: any): string;
}
export declare function resolve(...paths: string[]): string;
export declare function loadFile(absolutePath: string): string;
export declare function loadTemplate(absolutePath: string): Template;
export declare function registerPartial(name: string, content: string): void;
export declare function registerHelper(name: string, helper: (...args: any[]) => string | typeof Handlebars.SafeString): void;
export declare function loadPartial(name: string, absolutePath: string): void;
export declare function loadScript(absolutePath: string): any;
export declare function writeAutogenerated(absolutePath: string, content: string, header?: string): void;
export declare function writeScaffolded(absolutePath: string, content: string, overwrite?: boolean, header?: string): void;
export declare function watch(paths: string[], listener: () => void): void;
