"use strict";
var Bluebird = require('bluebird');
exports.EMISSION_DISPATCH = '@@EMISSION_DISPATCH';
exports.EMISSION_GET_STATE = '@@EMISSION_GET_STATE';
function emit(action, sideEffect) {
    var dispatch = action[exports.EMISSION_DISPATCH];
    var getState = action[exports.EMISSION_GET_STATE];
    if (dispatch && getState) {
        return Bluebird.delay(0).then(function () { return sideEffect(dispatch, getState); });
    }
    else {
        throw new Error('The emission middleware was not applied to the store. ' +
            'Or you have called emit in reducer initialization call.');
    }
}
exports.emit = emit;
exports.emissionMiddleware = function (_a) {
    var dispatch = _a.dispatch, getState = _a.getState;
    return function (next) {
        return function (action) {
            action[exports.EMISSION_DISPATCH] = dispatch;
            action[exports.EMISSION_GET_STATE] = getState;
            return next(action);
        };
    };
};
