import { Validator } from 'pretur.validation';
import { Model, Owner } from './model';
import { AbstractType, IntegerType, StringType } from './datatypes';
export * from './datatypes';
export interface Attribute<T> {
    name: string;
    type: AbstractType;
    owner?: Owner;
    required?: boolean;
    unique?: boolean;
    primary?: boolean;
    autoIncrement?: boolean;
    mutable?: boolean;
    defaultValue?: T;
    validator?: Validator<T>;
}
export interface PrimaryKeyOptions<T> {
    name: string;
    type?: IntegerType | StringType;
    autoIncrement?: boolean;
    mutable?: boolean;
    validator?: Validator<T>;
}
export declare function validateAttribute(attribute: Attribute<any>): void;
export declare function appendAttribute(model: Model<any>, ...attributes: Attribute<any>[]): void;
export interface AttributeBuilder {
    <T>(options: Attribute<T>): void;
    primaryKey<T>(options?: PrimaryKeyOptions<T>): void;
}
export declare function createAttributeBuilder(model: Model<any>): AttributeBuilder;
