import AbstractType from './AbstractType';
export interface EnumValue<TKey extends string> {
    name: TKey;
    i18nKey: string;
}
export default class EnumType<TKey extends string> extends AbstractType {
    name: string;
    values: EnumValue<TKey>[];
    private enumTypeName;
    readonly typeName: string;
    static is(obj: any): obj is EnumType<string>;
    static create<TKey extends string>(name: string, values: ([TKey, string] | EnumValue<TKey>)[], typeName?: string): EnumType<TKey>;
    private constructor(name, values, typeName?);
}
