"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var AbstractType_1 = require('./AbstractType');
var EnumType = (function (_super) {
    __extends(EnumType, _super);
    function EnumType(name, values, typeName) {
        var _this = this;
        if (typeName === void 0) { typeName = 'string'; }
        _super.call(this);
        this.name = name;
        this.enumTypeName = typeName;
        this.values = values
            .map(function (value) { return Array.isArray(value) ? ({ i18nKey: value[1], name: value[0] }) : value; })
            .filter(function (v) { return v; });
        if (process.env.NODE_ENV !== 'production') {
            if (this.values.length === 0) {
                throw new Error("enum " + name + " contains no value.");
            }
            this.values.forEach(function (pair) {
                if (typeof pair.name !== 'string') {
                    throw new Error("enum " + name + " has a value with no name.");
                }
                if (_this.values.filter(function (p) { return p.name === pair.name; }).length > 1) {
                    throw new Error("enum " + name + " has duplicate value names of " + pair.name + ".");
                }
            });
        }
    }
    Object.defineProperty(EnumType.prototype, "typeName", {
        get: function () {
            return this.enumTypeName;
        },
        enumerable: true,
        configurable: true
    });
    EnumType.is = function (obj) {
        return obj instanceof EnumType;
    };
    EnumType.create = function (name, values, typeName) {
        return new EnumType(name, values, typeName);
    };
    return EnumType;
}(AbstractType_1.default));
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = EnumType;
