"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var AbstractType_1 = require('./AbstractType');
var DateType_1 = require('./DateType');
var IntegerType_1 = require('./IntegerType');
var DoubleType_1 = require('./DoubleType');
var RangeType = (function (_super) {
    __extends(RangeType, _super);
    function RangeType(subType, typeName) {
        _super.call(this);
        if (process.env.NODE_ENV !== 'production') {
            if (!(subType instanceof AbstractType_1.default)) {
                throw new Error(subType + " is not a valid subtype for range.");
            }
            switch (true) {
                case subType instanceof DateType_1.default:
                case subType instanceof IntegerType_1.default:
                case subType instanceof DoubleType_1.default:
                    break;
                default:
                    throw new Error("Only Date, Integer and Double are allowed for Range types." +
                        (subType.typeName + " cannot be used in a range."));
            }
        }
        var defaultTypeName = "[" + subType.typeName + ", " + subType.typeName + "]";
        this.rangeSubtype = subType;
        this.rangeTypeName = typeName || defaultTypeName;
    }
    Object.defineProperty(RangeType.prototype, "typeName", {
        get: function () {
            return this.rangeTypeName;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RangeType.prototype, "subType", {
        get: function () {
            return this.rangeSubtype;
        },
        enumerable: true,
        configurable: true
    });
    RangeType.is = function (obj) {
        return obj instanceof RangeType;
    };
    RangeType.create = function (subType, typeName) {
        return new RangeType(subType, typeName);
    };
    return RangeType;
}(AbstractType_1.default));
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = RangeType;
