import AbstractType from './AbstractType';
import EnumType, { EnumValue } from './EnumType';
import BooleanType from './BooleanType';
import DoubleType from './DoubleType';
import IntegerType from './IntegerType';
import StringType from './StringType';
import ObjectType from './ObjectType';
import DateType from './DateType';
import RangeType from './RangeType';
export { AbstractType, EnumValue, EnumType, BooleanType, DoubleType, IntegerType, StringType, ObjectType, DateType, RangeType };
export declare const DataTypes: {
    BOOLEAN: () => BooleanType;
    DATE: (typeName?: string | undefined) => DateType;
    DOUBLE: () => DoubleType;
    ENUM: <TKey extends string>(name: string, values: (EnumValue<TKey> | [TKey, string])[], typeName?: string | undefined) => EnumType<TKey>;
    INTEGER: () => IntegerType;
    OBJECT: (typeName?: string | undefined) => ObjectType;
    RANGE: (subType: AbstractType, typeName?: string | undefined) => RangeType;
    STRING: () => StringType;
};
