"use strict";
var chai_1 = require('chai');
var Permission_1 = require('./fixture/Permission');
var Role_1 = require('./fixture/Role');
var User_1 = require('./fixture/User');
var UserPermission_1 = require('./fixture/UserPermission');
function init() {
    return {
        Permission: Permission_1.default.initialize(),
        Role: Role_1.default.initialize(),
        User: User_1.default.initialize(),
        UserPermission: UserPermission_1.default.initialize(),
    };
}
describe('pretur.spec interface testing fixture', function () {
    var _a = init(), Permission = _a.Permission, Role = _a.Role, User = _a.User, UserPermission = _a.UserPermission;
    it('should properly initialize all relations', function () {
        chai_1.expect(Permission.relationArray.map(function (a) { return a.alias; })).to.include('users');
        chai_1.expect(Role.relationArray.map(function (a) { return a.alias; })).to.include('users');
        chai_1.expect(User.relationArray.map(function (a) { return a.alias; })).to.include('role');
        chai_1.expect(User.relationArray.map(function (a) { return a.alias; })).to.include('permissions');
        chai_1.expect(UserPermission.relationArray.map(function (a) { return a.alias; })).to.include('user');
        chai_1.expect(UserPermission.relationArray.map(function (a) { return a.alias; })).to.include('permission');
    });
    it('should properly initialize all attributes', function () {
        chai_1.expect(Permission.attributeArray.map(function (a) { return a.name; })).to.include('id');
        chai_1.expect(Permission.attributeArray.map(function (a) { return a.name; })).to.include('name');
        chai_1.expect(Role.attributeArray.map(function (a) { return a.name; })).to.include('id');
        chai_1.expect(Role.attributeArray.map(function (a) { return a.name; })).to.include('name');
        chai_1.expect(User.attributeArray.map(function (a) { return a.name; })).to.include('id');
        chai_1.expect(User.attributeArray.map(function (a) { return a.name; })).to.include('firstName');
        chai_1.expect(User.attributeArray.map(function (a) { return a.name; })).to.include('lastName');
        chai_1.expect(User.attributeArray.map(function (a) { return a.name; })).to.include('roleId');
        chai_1.expect(UserPermission.attributeArray.map(function (a) { return a.name; })).to.include('userId');
        chai_1.expect(UserPermission.attributeArray.map(function (a) { return a.name; })).to.include('permissionId');
        chai_1.expect(UserPermission.indexes.unique[0]).to.deep.equal(['userId', 'permissionId']);
    });
});
