import { ModificationActions } from './relation';
import { UninitializedStateModel, Owner } from './model';
import { IntegerType, StringType, AttributeBuilder } from './attribute';
export interface JoinModelBuilder {
    attribute: AttributeBuilder;
}
export interface JoineeOptions {
    key?: string;
    type?: IntegerType | StringType;
    onDelete?: ModificationActions;
    onUpdate?: ModificationActions;
}
export interface Joinee {
    model: UninitializedStateModel<any>;
    aliasOnJoin: string;
    aliasOnTarget: string;
    key: string;
    type: IntegerType | StringType;
    onDelete: ModificationActions;
    onUpdate: ModificationActions;
}
export declare function joinee(model: UninitializedStateModel<any>, aliasOnJoin: string, aliasOnTarget: string, options?: JoineeOptions): Joinee;
export interface CreateJoinModelOptions {
    name: string;
    owner: Owner;
    firstJoinee: Joinee;
    secondJoinee: Joinee;
    virtual?: boolean;
}
export declare function createJoinModel<T>(options: CreateJoinModelOptions, initializer?: (modelBuilder: JoinModelBuilder) => void): UninitializedStateModel<T>;
