import { Validator } from 'pretur.validation';
import { AttributeBuilder, Attribute } from './attribute';
import { Relation, RelationsBuilder } from './relation';
import { Spec } from './spec';
export declare type Owner = null | string | string[];
export interface Indexes {
    unique: string[][];
}
export interface UninitializedStateModel<T> {
    model: Model<T>;
    name: string;
    owner: Owner;
    virtual: boolean;
    join: boolean;
    initialize: () => Spec<T>;
}
export interface Model<T> {
    name: string;
    owner: Owner;
    virtual: boolean;
    join: boolean;
    attributes: Attribute<any>[];
    indexes: Indexes;
    relations: Relation[];
    validator?: Validator<T>;
}
export interface CreateModelOptions {
    name: string;
    owner: Owner;
    virtual?: boolean;
}
export interface ModelBuilder<T> {
    attribute: AttributeBuilder;
    relation: RelationsBuilder;
    validator(validator: Validator<T>): void;
    multicolumnUniqueIndex(...fields: string[]): void;
}
export declare function createModel<T>(options: CreateModelOptions, initializer?: (modelBuilder: ModelBuilder<T>) => void): UninitializedStateModel<T>;
