import { Validator } from 'pretur.validation';
import { Indexes, Model, Owner } from './model';
import { Attribute } from './attribute';
import { Relation } from './relation';
export interface AttributeMap {
    [name: string]: Attribute<any>;
}
export interface Relations {
    superclass: Relation[];
    subclass: Relation[];
    master: Relation[];
    detail: Relation[];
    recursive: Relation[];
    manyToMany: Relation[];
    injective: Relation[];
    byAlias(alias: string): Relation;
}
export declare class Spec<T> {
    private model;
    private byAlias;
    private nonVirtualByAlias;
    readonly name: string;
    readonly owner: Owner;
    readonly virtual: boolean;
    readonly join: boolean;
    readonly validator: Validator<T> | undefined;
    readonly attributes: AttributeMap;
    readonly attributeArray: Attribute<any>[];
    readonly indexes: Indexes;
    readonly relations: Relations;
    readonly relationArray: Relation[];
    readonly nonVirtualRelations: Relations;
    readonly nonVirtualRelationArray: Relation[];
    readonly dependencies: string[];
    readonly nonVirtualDependencies: string[];
    constructor(model: Model<T>);
    filterByOwner(owner: Owner): Spec<T> | null;
}
