"use strict";
var fetch_1 = require('./fetch');
function buildOperator(endPointUrl) {
    return function operator(payload) {
        return fetch_1.fetch({
            body: payload,
            method: 'POST',
            url: endPointUrl,
        }).then(function (response) {
            return {
                data: response.body.data,
                errors: response.body.errors,
                name: response.body.name,
                ok: response.ok,
                status: response.status,
                statusText: response.statusText,
            };
        });
    };
}
exports.buildOperator = buildOperator;
function buildOperation(name) {
    function is(payloadOrResposnse) {
        return !!payloadOrResposnse && payloadOrResposnse.name === name;
    }
    function execute(operator, data) {
        return operator({ name: name, data: data });
    }
    return { name: name, is: is, execute: execute };
}
exports.buildOperation = buildOperation;
