"use strict";
function compose() {
    var validators = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        validators[_i - 0] = arguments[_i];
    }
    return function compositeValidator(value) {
        for (var i = 0; i < validators.length; i++) {
            if (typeof validators[i] === 'function') {
                var result = validators[i](value);
                if (result !== null) {
                    return result;
                }
            }
        }
        return null;
    };
}
exports.compose = compose;
