"use strict";
var chai_1 = require('chai');
var validator_1 = require('./validator');
describe('compose', function () {
    it('should return always-valid validator if non provided', function () {
        var validator = validator_1.compose();
        chai_1.expect(validator({})).to.be.null;
    });
    it('should return bail out with the first failed validation', function () {
        var validator = validator_1.compose(function (v) { return v > 1 ? null : { key: 'A' }; }, function (v) { return v > 2 ? null : { key: 'B' }; }, function (v) { return v > 3 ? null : { key: 'C' }; }, function (v) { return v > 4 ? null : { key: 'D' }; });
        chai_1.expect(validator(3)).to.deep.equal({ key: 'C' });
    });
});
