"use strict";
function exactLength(key, length, acceptEmpty) {
    if (acceptEmpty === void 0) { acceptEmpty = false; }
    return function exactLengthValidator(str) {
        if (acceptEmpty && !str) {
            return null;
        }
        if (typeof str !== 'string' || str.length !== length) {
            return { key: key, data: { ACCEPT_EMPTY: acceptEmpty, EXPECTED_LENGTH: length, VALUE: str } };
        }
        return null;
    };
}
exports.exactLength = exactLength;
