"use strict";
var chai_1 = require('chai');
var iban_1 = require('./iban');
describe('validator:iban', function () {
    it('should return null for valid input', function () {
        var validator = iban_1.iban('A');
        chai_1.expect(validator('AL47212110090000000235698741')).to.be.null;
        chai_1.expect(validator('IE29AIBK93115212345678')).to.be.null;
        chai_1.expect(validator('IR580540105180021273113007')).to.be.null;
    });
    it('should return bundle with {VALUE} for invalid input', function () {
        var validator = iban_1.iban('A');
        chai_1.expect(validator('blah')).to.deep.equal({ data: { VALUE: 'blah' }, key: 'A' });
    });
});
