"use strict";
var chai_1 = require('chai');
var integer_1 = require('./integer');
describe('validator:integer', function () {
    it('should return null for valid input', function () {
        var validator = integer_1.integer('A');
        chai_1.expect(validator(1)).to.be.null;
        chai_1.expect(validator(-1)).to.be.null;
        chai_1.expect(validator(0)).to.be.null;
        chai_1.expect(validator(1000000)).to.be.null;
    });
    it('should return bundle with {VALUE} for invalid input', function () {
        var validator = integer_1.integer('A');
        chai_1.expect(validator(0.1)).to.deep.equal({ data: { VALUE: 0.1 }, key: 'A' });
        chai_1.expect(validator(null)).to.deep.equal({ data: { VALUE: null }, key: 'A' });
        chai_1.expect(validator(undefined)).to.deep.equal({ data: { VALUE: undefined }, key: 'A' });
        chai_1.expect(validator(Number.NaN)).to.deep.equal({ data: { VALUE: Number.NaN }, key: 'A' });
        chai_1.expect(validator('blah')).to.deep.equal({ data: { VALUE: 'blah' }, key: 'A' });
        chai_1.expect(validator(Number.NEGATIVE_INFINITY)).to.deep.equal({
            data: { VALUE: Number.NEGATIVE_INFINITY },
            key: 'A',
        });
        chai_1.expect(validator(Number.POSITIVE_INFINITY)).to.deep.equal({
            data: { VALUE: Number.POSITIVE_INFINITY },
            key: 'A',
        });
    });
});
