"use strict";
function minimumLength(key, minimumLength, acceptEmpty) {
    if (acceptEmpty === void 0) { acceptEmpty = false; }
    return function minimumLengthValidator(str) {
        if (acceptEmpty && !str) {
            return null;
        }
        if (typeof str !== 'string' || str.length < minimumLength) {
            return {
                key: key,
                data: {
                    ACCEPT_EMPTY: acceptEmpty,
                    MINIMUM_LENGTH: minimumLength,
                    VALUE: str,
                },
            };
        }
        return null;
    };
}
exports.minimumLength = minimumLength;
