"use strict";
var chai_1 = require('chai');
var nonEmptyString_1 = require('./nonEmptyString');
describe('validator:nonEmptyString', function () {
    it('should return null for valid input', function () {
        var validator = nonEmptyString_1.nonEmptyString('A');
        chai_1.expect(validator('a')).to.be.null;
        chai_1.expect(validator('1')).to.be.null;
    });
    it('should return bundle with {VALUE} for invalid input', function () {
        var validator = nonEmptyString_1.nonEmptyString('A');
        chai_1.expect(validator(' ')).to.deep.equal({ data: { VALUE: ' ' }, key: 'A' });
        chai_1.expect(validator('    \n ')).to.deep.equal({ data: { VALUE: '    \n ' }, key: 'A' });
        chai_1.expect(validator('')).to.deep.equal({ data: { VALUE: '' }, key: 'A' });
        chai_1.expect(validator(null)).to.deep.equal({ data: { VALUE: null }, key: 'A' });
        chai_1.expect(validator(undefined)).to.deep.equal({ data: { VALUE: undefined }, key: 'A' });
    });
});
