"use strict";
var chai_1 = require('chai');
var numeric_1 = require('./numeric');
describe('validator:numeric', function () {
    it('should return null for valid input', function () {
        var validator = numeric_1.numeric('A');
        chai_1.expect(validator('123')).to.be.null;
        chai_1.expect(validator('')).to.be.null;
        chai_1.expect(validator('0')).to.be.null;
        chai_1.expect(validator('0x11')).to.be.null;
        chai_1.expect(validator('0b11')).to.be.null;
        chai_1.expect(validator('0o11')).to.be.null;
        chai_1.expect(validator('1.0')).to.be.null;
        chai_1.expect(validator('1e-2')).to.be.null;
        chai_1.expect(validator('1.999e2')).to.be.null;
        chai_1.expect(validator(null)).to.be.null;
        chai_1.expect(validator(undefined)).to.be.null;
    });
    it('should return bundle with {VALUE} for invalid input', function () {
        var validator = numeric_1.numeric('A');
        chai_1.expect(validator('blah')).to.deep.equal({ data: { VALUE: 'blah' }, key: 'A' });
    });
});
