"use strict";
function rangedNumber(key, from, to, inclusiveFrom, inclusiveTo) {
    if (from === void 0) { from = Number.NEGATIVE_INFINITY; }
    if (to === void 0) { to = Number.POSITIVE_INFINITY; }
    if (inclusiveFrom === void 0) { inclusiveFrom = true; }
    if (inclusiveTo === void 0) { inclusiveTo = true; }
    return function rangedNumberValidator(num) {
        if (typeof num !== 'number' ||
            isNaN(num) ||
            (inclusiveFrom ? num < from : num <= from) ||
            (inclusiveTo ? num > to : num >= to)) {
            return {
                key: key,
                data: {
                    FROM: from,
                    INCLUSIVE_FROM: inclusiveFrom,
                    INCLUSIVE_TO: inclusiveTo,
                    TO: to,
                    VALUE: num,
                },
            };
        }
        return null;
    };
}
exports.rangedNumber = rangedNumber;
